#!/usr/local/bin/thrift -cpp -java -py -php -rb -perl -erl -xsd -r

 /** Structs are the basic complex data structures. They are comprised of fields 
   * which each have an integer identifier, a type, a symbolic name, and an 
   * optional default value. */

   struct Lookup {
    1:string bucket,
    2:string key
   }

  /* Structs can also be exceptions, if they are nasty. */
  exception InvalidKey {
   1: string error
  }

service QService {

  /**
   * A method definition looks like C code. It has a return type, arguments,
   * and optionally a list of exceptions that it may throw. Note that argument
   * lists and exception lists are specified using the exact same syntax as
   * field lists in struct or exception definitions.
   */

   i32 exponent(1:i32 base, 2:i32 exp),
   string get_key(1:Lookup l) throws (1:InvalidKey e),
   async void run_task()

}