#!/usr/bin/env ruby

$:.push('../gen-rb')

require 'thrift/transport/tsocket.rb'
require 'thrift/protocol/tbinaryprotocol.rb'

require 'QService'

begin
  port = ARGV[0] || 9090
  
  transport = TBufferedTransport.new(TSocket.new('localhost', port))
  protocol = TBinaryProtocol.new(transport)
  client = QService::Client.new(protocol)

  transport.open()

  # Run a remote calculation
  answer = client.exponent(50,2)
  print "50**2=", answer, "\n"

  # Run a 'cache' lookup 
  lookup = Lookup.new()
  lookup.bucket = 'bucket1'
  lookup.key = 'key1'
 
  print "Lookup: ", client.get_key(lookup), "\n"

  # Force a cache miss
  begin
    lookup.bucket = 'bucket2'
    print "Lookup: ", client.get_key(lookup), "\n"
  rescue InvalidKey => e
    print "InvalidKey: ", e.error, "\n"
  end
  
  print client.run_task()

  transport.close()

rescue TException => tx
  print 'TException: ', tx.message, "\n"
end