#!/usr/bin/env ruby

$:.push('../gen-rb')

require 'thrift/transport/tsocket'
require 'thrift/protocol/tbinaryprotocol'
require 'thrift/server/tserver'

require 'QService'

class QServiceHandler
  def initialize()
    @log = {}
    @hash = {'bucket1' => {'key1' => 'value1'}}
  end

  def exponent(base, exp)
    print "#{base}**#{exp}\n"
    return base**exp
  end

  def get_key(lookup)
   if @hash[lookup.bucket][lookup.key]
     return @hash[lookup.bucket][lookup.key]
   else
     e = InvalidKey.new
     e.error = 'Cache miss'
     raise e
   end
  end

  def run_task()
    print "kick off long running task...\n"
  end

end

handler = QServiceHandler.new()
processor = QService::Processor.new(handler)
transport = TServerSocket.new(9090)
transportFactory = TBufferedTransportFactory.new()
server = TSimpleServer.new(processor, transport, transportFactory)

puts "Starting the QService server..."
server.serve()
puts "done."